import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JOptionPane;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Container;
import java.util.Iterator;
/**
 * Klasse Gui fr das Mittelwertprojekt.
 * 
 * @author (claus albowski) 
 * @version (feb 06)
 */
public class Gui
extends JFrame
{
    // Instanzvariable
    JLabel labelZahl;
    JTextField editZahl;
    JButton uebernehmenButton, mittelwertButton, endeButton;
    JTextArea ausgabe;
    Messreihe messreihe;

    /**
     * Konstruktor fr Objekte der Klasse Gui
     */
    public Gui()
    {
        super("Messreihe mit Mittelwert");
        setBounds(20, 20, 360, 270); // x, y, width, height
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt){ beendenAction(); }
        });
        Container cp = getContentPane();
        cp.setLayout(null);
        messreihe=null;
        setJMenuBar(machMenueLeiste());
                
        // Label
        labelZahl = new JLabel("Eingabe Messwert");
        labelZahl.setBounds(10, 10, 120, 20);
        cp.add(labelZahl);
        
        // Textfelder
        editZahl = new JTextField("");
        editZahl.setBounds(10, 40, 120, 20);
        cp.add(editZahl);
        
        // Buttons
        uebernehmenButton = new JButton ("OK");
        uebernehmenButton.setBounds(10, 70, 120, 20);
        cp.add(uebernehmenButton);
                
        mittelwertButton = new JButton ("Mittelwert");
        mittelwertButton.setBounds(10, 100, 120, 20);
        cp.add(mittelwertButton);
                
        endeButton = new JButton ("ENDE");
        endeButton.setBounds(10, 180, 120, 20);
        cp.add(endeButton);
        
        // Textarea
        ausgabe = new JTextArea();
        ausgabe.setText(null);
        JScrollPane scroll = new JScrollPane(ausgabe);
        scroll.setBounds(140, 10, 200, 200);
        cp.add(scroll);
        
        
        // Listener
        uebernehmenButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK OK
            public void actionPerformed(ActionEvent e) { uebernehmenAction(); }
        });
        
        mittelwertButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK MW
            public void actionPerformed(ActionEvent e) { mittelwertAction(); }
        });

        endeButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK ENDE
            public void actionPerformed(ActionEvent e) { beendenAction(); }
        });
    }

    private JMenuBar machMenueLeiste() {
        // Definition Menleiste
        JMenuBar menueLeiste = new JMenuBar();
        // Definition Datei-Men
        JMenu menueDatei = new JMenu("Datei");
        // Definition der Eintrge im Datei-Men
        JMenuItem menueEintragNeu = new JMenuItem("neue Messreihe");
        JMenuItem menueEintragEnde = new JMenuItem("Ende");
        // Definition Bearbeiten-Men
        JMenu menueBearbeiten = new JMenu("Bearbeiten");
        // Definition der Eintrge im Bearbeiten-Men
        JMenuItem menueEintragAusgabe = new JMenuItem("Ausgabe der Messwerte");
        JMenuItem menueEintragMittelwert = new JMenuItem("Ausgabe des Mittelwertes");
        // Hizufgen der Men-Elemente in der richtigen Reihenfolge
        menueDatei.add(menueEintragNeu);
        menueDatei.add(menueEintragEnde);
        menueBearbeiten.add(menueEintragAusgabe);
        menueBearbeiten.add(menueEintragMittelwert);
        menueLeiste.add(menueDatei);
        menueLeiste.add(menueBearbeiten);
        
        // Hinzufgen der Action-Listener
        menueEintragNeu.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) { neuAction(); }
        });

        menueEintragEnde.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e)  { beendenAction(); }
        });

        menueEintragMittelwert.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) { mittelwertAction(); }
        });

        menueEintragAusgabe.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) { ausgabeAction(); }
        });

        return menueLeiste;
    }
    
    // Definition der Aktionen
    private void neuAction(){ messreihe=null; }
    private void beendenAction(){ 
        if (JOptionPane.showConfirmDialog(this, "wirklich beenden?", "prfen" , JOptionPane.OK_CANCEL_OPTION)==JOptionPane.OK_OPTION)
        System.exit(0);
    }
    private void mittelwertAction(){
        if (messreihe!=null) ausgabe.setText("Mittelwert: "+messreihe.mittelwert());
    }
    private void ausgabeAction(){
        ausgabe.setText(null);
        if (messreihe!=null)
        for (Iterator<Double> it=messreihe.gibMesswerte().iterator(); it.hasNext();)
        ausgabe.append(it.next().doubleValue()+"\r\n");
    }
    private void uebernehmenAction(){
        Double zahl=gibDoubleZahl(editZahl.getText());
        if (zahl==null) {
            ausgabe.setText("Zahl eingeben!");
        }
        else {
            if (messreihe==null) { messreihe=new Messreihe(zahl); }
            else { messreihe.neuerMesswert(zahl); }
            ausgabe.setText("Eingabe: "+zahl);
        }
        editZahl.setText("");
        editZahl.grabFocus();
    }
    
    private Double gibDoubleZahl(String text){
        Double neu=null;
        try {
            neu = new Double(text).doubleValue();
            }
            catch (NumberFormatException exc){ return null;}
        return neu;
    }
    
    public static void main(String[] par){
        Gui gui=new Gui();
        gui.setVisible(true);
    }
}
